.586
.MMX
.model flat,stdcall
option casemap: none

include Sokoban.inc
;
.code
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Start:
	;invoke GetModuleHandle, NULL
	;mov hInstance, eax

      ;===================================  
      ;=    800x600.   =
      ;===================================
      invoke GetSystemMetrics, SM_CXSCREEN
      mov ebx, eax
      invoke GetSystemMetrics, SM_CYSCREEN

      cmp ebx, 800
      jb ModeReq
      cmp eax, 600
      jb ModeReq  
      jmp NormalCont
        
ModeReq:
        invoke MessageBox, NULL, OFFSET ScreenRes, OFFSET ScreenResCaption, MB_OK or MB_ICONERROR
        jmp FastExit    

NormalCont:
      ; WinMain  
	invoke 	WinMain, hInstance, NULL, NULL, SW_SHOWNORMAL
FastExit:
	invoke 	ExitProcess,eax
;===============================================================================



;===============================================================================
;= WinMain
;===============================================================================
WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    
    ;================================================
    ;  WNDCLASSEX 
    ;================================================
	mov   	wc.cbSize,SIZEOF WNDCLASSEX
	mov   	wc.style, CS_HREDRAW or CS_VREDRAW
	mov   	wc.lpfnWndProc, OFFSET WndProc
	mov   	wc.cbClsExtra,NULL
	mov   	wc.cbWndExtra,NULL
	m2m  	      wc.hInstance, hInstance
	mov   	wc.hbrBackground,COLOR_WINDOW
	mov   	wc.lpszMenuName, MainMenu;10000;OFFSET MenuName
	mov   	wc.lpszClassName,OFFSET ClassName
	invoke 	LoadIcon, hInstance, IDI_ICONBIG
	mov   	wc.hIcon, eax
	invoke 	LoadIcon, hInstance, IDI_ICONSMALL
	mov   	wc.hIconSm, eax
	invoke 	LoadCursor,NULL,IDC_ARROW
	mov   	wc.hCursor,eax
	invoke 	RegisterClassEx, addr wc
	invoke 	CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           	                     WS_OVERLAPPEDWINDOW-WS_MAXIMIZEBOX-WS_SIZEBOX,\
           	                     CW_USEDEFAULT, CW_USEDEFAULT,wWidth,wHeight,NULL,0,\
           	                     hInst,NULL
      mov         hWindow, eax
      invoke GetMenu,eax
      mov hMenu,eax

      invoke LoadAccelerators, hInstance, addr MyAccel
      mov hAccel, eax
      
	invoke 	ShowWindow, hWindow, CmdShow
	invoke 	UpdateWindow, hWindow
      ;================================================
      ;     
      ;================================================
	.WHILE 	TRUE
		invoke 	GetMessage, ADDR msg,NULL,0,0
		.BREAK 	.IF (!eax)
		invoke 	TranslateMessage, ADDR msg
            invoke      TranslateAccelerator, hWindow, hAccel, ADDR msg
		invoke 	DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp
;===============================================================================


;===============================================================================
;=    
;===============================================================================
ProcessKey PROC Dir: DWORD
  .IF !ManMoving
    call UndoPush
    
    push Dir
    pop Direction
    invoke AskForMove
    .IF eax
        mov KeyPressed, eax
        mov ManMoving, FALSE
        mov BoxMoving, FALSE
        invoke MoveBox
        invoke MoveMan
        .IF !UndoEnable
   			mov UndoEnable,TRUE
   			invoke EnableMenuItem,hMenu,IDM_UNDO,MF_ENABLED
   		.ENDIF

    .ENDIF
  .ENDIF                    
   
    ret
ProcessKey ENDP
;================================================================================

DlgProc PROC hWnd:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM
	.if iMsg==WM_CLOSE
		invoke EndDialog,hWnd,NULL
	.elseif iMsg==WM_COMMAND
		mov eax,wParam
		mov edx,eax
		shr edx,16
		.if dx==BN_CLICKED
			.if eax==IDC_OK
				invoke SendMessage,hWnd,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.else
		mov eax,FALSE
		ret
	.endif
	mov  eax,TRUE
	ret
DlgProc endp



;===============================================================================
;	Window procedure
;===============================================================================	
WndProc proc uses ebx esi hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    LOCAL	hDC:DWORD         ;    
    LOCAL	ps:PAINTSTRUCT    ; 
    LOCAL	TempRect:RECT     ;
    
      ;============================================================
      ; WM_CREATE
      ;============================================================
	.IF 	uMsg == WM_CREATE

            invoke Do_Status,hWnd           ;  


			;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
			;------------------------------------------- get height of status bar
			invoke GetWindowRect, hStatus, addr TempRect
			mov eax, TempRect.bottom
			sub eax, TempRect.top
			mov ebx, eax
			add eax, 16*TILE_HEIGHT
			invoke SetRect, addr TempRect, 0, 0, 20 * TILE_WIDTH, eax
			;------------------------------------------- calc new dimensions
			invoke AdjustWindowRectEx, addr TempRect, WS_OVERLAPPEDWINDOW, TRUE, NULL
			mov eax, TempRect.right
			sub eax, TempRect.left
			mov ecx, TempRect.bottom
			sub ecx, TempRect.top
			;------------------------------------------- set new window size
			invoke SetWindowPos, hWnd, NULL, 0, 0, eax, ecx, SWP_NOMOVE or SWP_NOZORDER
			;------------------------------------------- reposition statusbar
			invoke GetClientRect, hWnd, addr TempRect
			mov ecx, TempRect.bottom
			sub ecx, ebx
			mov edx, TempRect.right
			sub edx, TempRect.left
			invoke SetWindowPos, hStatus, NULL, 0, ecx, edx, ebx, SWP_NOZORDER
			;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

            ;=================================================
            ;    / 
            ;=================================================
		mov  ofn.lStructSize,SIZEOF ofn
		m2m  ofn.hWndOwner, hWnd
		m2m  ofn.hInstance, hInstance
		mov  ofn.lpstrFilter, OFFSET FilterString
		mov  ofn.lpstrFile, OFFSET buffer
		mov  ofn.nMaxFile,MAXSIZE
            mov  ofn.lpstrDefExt, OFFSET DefExt

            invoke SetTimer, hWnd, NULL, 40, NULL
            mov Timer, eax
            invoke Prepare, hWnd

            invoke LoadLevel, 0
            call UndoPush
            invoke InvalidateRect, hWnd, NULL, FALSE
            
      ;============================================================
      ; WM_COMMAND
      ;============================================================            
      .ELSEIF uMsg == WM_COMMAND		
            mov eax,wParam
		.IF ax==IDM_EXIT
                jmp Exit
            .ELSEIF ax==IDM_NEWGAME
                invoke LoadLevel, 0
                invoke InvalidateRect, hWnd, NULL, FALSE
            .ELSEIF ax==IDM_RESTART
                invoke LoadLevel, CurLevel 
                invoke InvalidateRect, hWnd, NULL, FALSE
            .ELSEIF ax==IDM_SAVE
                invoke LevelSaveFile
            .ELSEIF ax==IDM_LOAD
                invoke LevelLoadFile
            .ELSEIF ax==IDM_UNDO
                invoke UndoPop                
            .ELSEIF ax==IDM_ABOUT
                invoke DialogBoxParam,hInstance, IDD_ABOUTDLG,hWnd,OFFSET DlgProc,NULL
            .ENDIF
      ;============================================================
      ; WM_TIMER
      ;============================================================            
      .ELSEIF uMsg == WM_TIMER
            .IF ManMoving
                mov eax, BoxMoving
                and eax, Pushing
                .IF eax
                    invoke MoveBox
                .ENDIF   
                invoke MoveMan
            .ENDIF        

      ;============================================================
      ; WM_USER+100   -- LEVEL FINISHED
      ;============================================================            
      .ELSEIF uMsg == WM_USER+100 ;Level finished
             jmp @F
             Great      db "!",0
          @@:
             invoke MessageBox, hWnd, OFFSET Great, OFFSET Great, MB_OK   
             inc CurLevel
             .IF CurLevel>MAX_LEVELS
                mov CurLevel, 0
             .ENDIF
             invoke LoadLevel, CurLevel
             invoke InvalidateRect, hWnd, NULL, FALSE
      ;============================================================
      ; WM_PAINT
      ;============================================================            
	.ELSEIF uMsg == WM_PAINT

            invoke      GetUpdateRect, hWnd, ADDR TempRect, TRUE
            .IF eax
                  invoke	BeginPaint, hWnd, ADDR ps
		      mov		hDC,eax

                  mov eax, TempRect.right
                  mov ebx, TempRect.bottom
                  sub eax, TempRect.left
                  sub ebx, TempRect.top  
		      invoke	BitBlt, hDC, TempRect.left, TempRect.top, \
                              eax, ebx, hBackDC, \
                              TempRect.left, TempRect.top, SRCCOPY
                              
    		      invoke	EndPaint, hWnd, ADDR ps
            .ENDIF   
            
      ;============================================================
      ; WM_KEYDOWN
      ;============================================================            
      .ELSEIF uMsg == WM_KEYDOWN
         ;=========================
         ;   ?
         ;=========================
            .IF wParam==VK_LEFT
                invoke ProcessKey, LEFT                
            .ELSEIF wParam==VK_RIGHT
                invoke ProcessKey, RIGHT
            .ELSEIF wParam==VK_UP
                invoke ProcessKey, UP                
            .ELSEIF wParam==VK_DOWN
                invoke ProcessKey, DOWN   
            .ENDIF                                                     
      .ELSEIF uMsg == WM_KEYUP
        mov KeyPressed, FALSE
      ;============================================================
      ; WM_DESTROY
      ;============================================================            
	.ELSEIF uMsg == WM_DESTROY
Exit:
            invoke      KillTimer, hWnd, Timer
            invoke      Delete
		invoke	PostQuitMessage, NULL
	.ELSE
		invoke 	DefWindowProc,hWnd,uMsg,wParam,lParam		
		;ret
	.ENDIF
ret
WndProc endp
;
;
        end     Start

